void checkCollisions()
{
      int i, j, k,
          firedByShip,
          objectListSize = objectList.size(),
          bulletListSize = bulletList.size(),
          turretListSize = turretList.size(),
          playerListSize = playerList.size();

      //For all objects in objectList
      for ( i = 0 ; i < objectListSize ; i++ )
      {
            if ( objectList[i].affectedByBullets || objectList[i]. killsBullets)
            {
                  //If object can be destroyed by bullets
                  if ( objectList[i].affectedByBullets == IS_DESTROYED )
                  {
                        //Check all bullets against object, see if object was destroyed
                        for ( j = 0 ; j < bulletListSize ; j++ )
                        {
                              //If bullet and object colliding
                              if ( bulletList[j].exist && areColliding( objectList[i].x, objectList[i].y, bulletList[j].x, bulletList[j].y,
                                                                        objectList[i].image->w, objectList[i].image->h, bulletList[j].image->w, bulletList[j].image->h ) )
                              {
                                    //Indicate object destroyed
                                    objectList[i].exist = 0;

                                    //Kill bullet if necessary
                                    if ( bulletList[j].killable && objectList[i].killsBullets )
                                          bulletList[j].exist = 0;
                                    //break;
                              }
                        }
                  }
                  //If object is Asteroid and asteroid can be broken up
                  else if ( objectList[i].affectedByBullets == IS_BROKEN_UP )
                  {
                        //Check all bullets against object, see if object was destroyed
                        for ( j = 0 ; j < bulletListSize ; j++ )
                        {
                              //If bullet and asteroid colliding
                              if ( bulletList[j].exist && areColliding( objectList[i].x, objectList[i].y, bulletList[j].x, bulletList[j].y,
                                                                                                         objectList[i].image->w, objectList[i].image->h, bulletList[j].image->w, bulletList[j].image->h ) )
                              {
                                    //Break up asteroid
                                    if ( objectList[i].name == ASTEROID )
                                    {
                                          //assume that bullet was not fired by a ship
                                          firedByShip = false;

                                          //test if the bullet was fired by any of the ships
                                          for ( k = 0 ; k < playerListSize ; k++ )
                                                if ( bulletList[j].ID == playerList[k].theShip.ID )
                                                      firedByShip = true;

                                          //if bullet was fired by a ship
                                          if ( firedByShip )
                                          {

                                                //Create an explosion effect
                                                createExplosion( ( objectList[i].image->w * objectList[i].image->h ) / 15,
                                                                 250 * sqrtf( ( bulletList[j].xVel * bulletList[j].xVel ) + ( bulletList[j].yVel * bulletList[j].yVel ) ),
                                                                 objectList[i].x,
                                                                 objectList[i].y,
                                                                 objectList[i].xVel,
                                                                 objectList[i].yVel,
                                                                 explosionParticleImage );

                                                //Play sound effect
                                                if ( playSounds )
                                                      Mix_PlayChannel( -1, asteroidHit, 0 );

                                                if ( objectList[i].numOfLives > 1 )
                                                {
                                                      objectList[i].sizeOfObject--;
                                                      objectList[i].numOfLives--;
                                                      for ( k = 0 ; k < myLevel.asteroidSplitCount ; k++ )
                                                            objectList.push_back( createAsteroid( objectList[i].x + ( rand() % 1000 ) / 300,
                                                                                                  objectList[i].y + ( rand() % 1000 ) / 300,
                                                                                                  objectList[i].xVel + objectList[i].breakupSpeed * ( rand() % 1000 ) / 250.0,
                                                                                                  objectList[i].yVel + objectList[i].breakupSpeed * ( rand() % 1000 ) / 250.0,
                                                                                                  objectList[i].hasPull,
                                                                                                  objectList[i].sizeOfObject,
                                                                                                  objectList[i].numOfLives,
                                                                                                  objectList[i].breakupSpeed ) );
                                                }
                                                objectList[i].exist = 0;

                                                //Increase player score for the player that fired the bullet
                                                for ( k = 0 ; k < playerListSize ; k++ )
                                                      if ( bulletList[j].ID == playerList[k].theShip.ID )
                                                            playerList[k].score += (int)( ( 6 - .75 * objectList[i].sizeOfObject ) * ( 6 - .75 * objectList[i].sizeOfObject ) );
                                          }
                                          else if ( bulletList[j].killable )
                                                bulletList[j].exist = 0;
                                    }

                                    //Kill bullet if necessary
                                    if ( bulletList[j].killable && objectList[i].killsBullets )
                                          bulletList[j].exist = 0;
                                    //break;
                              }
                        }
                  }
            }
      }

      for ( k = 0 ; k < playerListSize ; k++ )
      {
            //If ship can be affected
            if ( playerList[k].theShip.exist && !playerList[k].theShip.invincible )
            {
                  //Check all bullets against ship, see if ship was destroyed
                  for ( j = 0 ; j < bulletListSize && playerList[k].theShip.exist ; j++ )
                  {
                        //If bullet and ship colliding
                        if ( bulletList[j].ID != playerList[k].theShip.ID && bulletList[j].exist && areColliding( playerList[k].theShip.x, playerList[k].theShip.y, bulletList[j].x, bulletList[j].y,
                                                                                                   shipImages[ playerList[k].theShip.colorNum ].image->w, shipImages[ playerList[k].theShip.colorNum ].image->h, bulletList[j].image->w, bulletList[j].image->h ) )
                        {
                              //If bullet can kill ships
                              if ( bulletList[j].killsShips )
                              {
                                    destroyShip( k );

                                    //Kill bullet if necessary
                                    if ( bulletList[j].killable )
                                          bulletList[j].exist = 0;
                              }
                        }
                  }

                  //Check all objects against ship, see if ship was destroyed
                  for ( i = 0 ; i < objectListSize && playerList[k].theShip.exist ; i++ )
                  {
                        //If object and ship colliding
                        if ( objectList[i].exist && objectList[i].killsShips && areColliding( playerList[k].theShip.x, playerList[k].theShip.y, objectList[i].x, objectList[i].y,
                                                                                              shipImages[ playerList[k].theShip.colorNum ].image->w, shipImages[ playerList[k].theShip.colorNum ].image->h, objectList[i].image->w, objectList[i].image->h ) )
                        {
                              destroyShip( k );
                        }
                  }
            }
      }

      //Check bullets against all turrets
      for ( i = 0 ; i < bulletListSize ; i++ )
      {
            for ( j = 0 ; j < turretListSize ; j++ )
            {
                  if ( bulletList[i].ID != turretList[j].ID && bulletList[i].killable && areColliding( bulletList[i].x, bulletList[i].y, turretList[j].x, turretList[j].y,
                                                                                                       bulletList[i].image->w, bulletList[i].image->h, turretList[j].image->w, turretList[j].image->h ) )
                        bulletList[i].exist = 0;
            }
      }
}
