void free_surfaces()
{
      int i;

      //Free all the surfaces except the screen
      SDL_FreeSurface( background );
      SDL_FreeSurface( planetImage );
      SDL_FreeSurface( asteroidImage_1 );
      SDL_FreeSurface( asteroidImage_2 );
      SDL_FreeSurface( asteroidImage_3 );
      SDL_FreeSurface( asteroidImage_4 );
      SDL_FreeSurface( asteroidImage_5 );
      SDL_FreeSurface( shipBulletImage );
      SDL_FreeSurface( turretBulletImage );
      SDL_FreeSurface( turretImage );
      SDL_FreeSurface( exaustParticleImage );
      SDL_FreeSurface( explosionParticleImage );
      SDL_FreeSurface( crosshairsImage );

      //Clean up all ship images
      for ( i = 0 ; i < shipImages.size() ; i++ )
      {
            SDL_FreeSurface( shipImages[i].image );
            SDL_FreeSurface( shipImages[i].previewImage );
            SDL_FreeSurface( shipImages[i].particleImage );
      }
}

void clean_up()
{
      int i;

      //Free the sound effects
      Mix_FreeChunk( shipFire );
      Mix_FreeChunk( turretFire );
      Mix_FreeChunk( asteroidHit );
      Mix_FreeChunk( engine );

      //Free the music
      Mix_FreeMusic( music );

      //Quit SDL_mixer
      Mix_CloseAudio();

      for ( i = 0 ; i < playerList.size() ; i++ )
      {
            //If player has joystick opened, close it
            if( playerList[i].joystick != NULL )
                  SDL_JoystickClose( playerList[i].joystick );
      }

      //Close the fonts that were used
      TTF_CloseFont( miniFont );
      TTF_CloseFont( smallFont );
      TTF_CloseFont( largeFont );

      //Quit SDL_ttf
      TTF_Quit();

      //Quit SDL
      SDL_Quit();
}
