int configureSettings()
{
      int inMenu = true,
          fpsTimer,
          newWidth = SCREEN_WIDTH,
          newHeight = SCREEN_HEIGHT,
          newSampleSize = SAMPLE_SIZE,
          newSampleRate = SAMPLE_RATE,
          newSoundVolume = SOUND_VOLUME,
          newMusicVolume = MUSIC_VOLUME,
          timeSinceHit = SDL_GetTicks(),
          spotOnMenu = 0,
          menuSize = 8; //Number of entries in the menu

      float newspeedMod = speedMod;

      while ( inMenu )
      {
            //Start the frame timer
            fpsTimer = SDL_GetTicks();

            //Display the background
            applySurface( 0, 0, background, screen );

            //Update asteroids
            objectListUpdate();
            eventNoticeUpdate();
            checkBounds( false );

            //Reapply surfaces
            applySurfaces( 0, 1, 0, 1, 0, 1, 0, 0 );

            //Display the title
            displayTitle();

            if ( spotOnMenu == 0 || spotOnMenu == 1 || spotOnMenu == 2 || spotOnMenu == 3 )
            {
                  text = TTF_RenderText_Solid( miniFont, "hold [left ctrl] to jump by tens", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 3 * text->h, text, screen );
                  SDL_FreeSurface( text );
                  text = TTF_RenderText_Solid( miniFont, "hold [left ctrl] + [left shift] to jump by hundreds", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 2 * text->h, text, screen );
                  SDL_FreeSurface( text );
            }

            if ( spotOnMenu == 2 || spotOnMenu == 3 )
            {
                  text = TTF_RenderText_Solid( miniFont, "NOT FULLY IMPLEMENTED - CHANGE AT YOUR OWN RISK", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 5 * text->h, text, screen );
                  SDL_FreeSurface( text );
                  text = TTF_RenderText_Solid( miniFont, "hold [left ctrl] to jump by tens", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 3 * text->h, text, screen );
                  SDL_FreeSurface( text );
                  text = TTF_RenderText_Solid( miniFont, "hold [left ctrl] + [left shift] to jump by hundreds", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 2 * text->h, text, screen );
                  SDL_FreeSurface( text );
                  text = TTF_RenderText_Solid( miniFont, "hold [left ctrl] + [left shift] + [left alt] to jump by thousands", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 1 * text->h, text, screen );
                  SDL_FreeSurface( text );
            }

            if ( spotOnMenu == 4 || spotOnMenu == 5 )
            {
                  text = TTF_RenderText_Solid( miniFont, "Volume is out of 128", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 5 * text->h, text, screen );
                  SDL_FreeSurface( text );
                  text = TTF_RenderText_Solid( miniFont, "hold [left ctrl] to jump by tens", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 3 * text->h, text, screen );
                  SDL_FreeSurface( text );
            }

            if ( spotOnMenu == 6 )
            {
                  text = TTF_RenderText_Solid( miniFont, "hold [left ctrl] to jump by .1", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 5 * text->h, text, screen );
                  SDL_FreeSurface( text );
                  text = TTF_RenderText_Solid( miniFont, "1.0 is normal, .5 is half speed, 2 is double speed, etc.", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 3 * text->h, text, screen );
                  SDL_FreeSurface( text );
                  text = TTF_RenderText_Solid( miniFont, "Has no effect on performance", blackColour );
                  applySurface( SCREEN_WIDTH / 2 - text->w/2, SCREEN_HEIGHT - 2 * text->h, text, screen );
                  SDL_FreeSurface( text );
            }


            myStringstream.clear();
                  myStringstream.str("");
            myStringstream << "Screen Width: " << newWidth;

            if ( spotOnMenu == 0 )
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 4 * text->h, text, screen );
            SDL_FreeSurface( text );


            myStringstream.clear();
            myStringstream.str("");
            myStringstream << "Screen Height: " << newHeight;

            if ( spotOnMenu == 1 )
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 5 * text->h, text, screen );
            SDL_FreeSurface( text );

            myStringstream.clear();
            myStringstream.str("");
            myStringstream << "Sample Size: " << newSampleSize;

            if ( spotOnMenu == 2 )
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 6 * text->h, text, screen );
            SDL_FreeSurface( text );

            myStringstream.clear();
            myStringstream.str("");
            myStringstream << "Sample Rate: " << newSampleRate;

            if ( spotOnMenu == 3 )
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 7 * text->h, text, screen );
            SDL_FreeSurface( text );


            myStringstream.clear();
            myStringstream.str("");
            myStringstream << "Sound Volume: " << newSoundVolume;

            if ( spotOnMenu == 4 )
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 8 * text->h, text, screen );
            SDL_FreeSurface( text );


            myStringstream.clear();
            myStringstream.str("");
            myStringstream << "Music Volume: " << newMusicVolume;

            if ( spotOnMenu == 5 )
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 9 * text->h, text, screen );
            SDL_FreeSurface( text );

            myStringstream.clear();
            myStringstream.str("");
            myStringstream << "Game Speed: " << newspeedMod;

            if ( spotOnMenu == 6 )
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, myStringstream.str().c_str(), blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 10 * text->h, text, screen );
            SDL_FreeSurface( text );

            if ( spotOnMenu == 7 )
                  text = TTF_RenderText_Solid( smallFont, "Apply changes", whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, "Apply changes", blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 11 * text->h, text, screen );
            SDL_FreeSurface( text );

            if ( spotOnMenu == 8 )
                  text = TTF_RenderText_Solid( smallFont, "Cancel", whiteColour );
            else
                  text = TTF_RenderText_Solid( smallFont, "Cancel", blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, 12 * text->h, text, screen );
            SDL_FreeSurface( text );


            //Toggle fullscreen if user pressed alt-enter
            keystates = SDL_GetKeyState( NULL );
            checkFullscreenToggle();

            //While there's events to handle
            while( SDL_PollEvent( &event ) )
            {
                  //If the user has Xed out the window
                  if ( event.type == SDL_QUIT )
                  {
                        //Quit the program
                        quitGame( 0 );
                  }

                  if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_DOWN )
                  {
                        spotOnMenu++;
                  }

                  if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_UP )
                  {
                        spotOnMenu--;
                  }

                  if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_RETURN  && spotOnMenu > 5)
                        inMenu = false;
            }

            if ( spotOnMenu < 0 )
                  spotOnMenu = menuSize;
            else if ( spotOnMenu > menuSize )
                  spotOnMenu = 0;

            //If user pressed right
            if ( keystates[ SDLK_RIGHT ] && SDL_GetTicks() - timeSinceHit > keystrokeDelay / 2.0 )
            {
                  if ( spotOnMenu == 0 )
                        newWidth += 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 1 )
                        newHeight += 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 2 )
                        newSampleSize += 900 * keystates[ SDLK_LALT ] * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 3 )
                        newSampleRate += 900 * keystates[ SDLK_LALT ] * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 4 && newSoundVolume + 9 * keystates[ SDLK_LCTRL ] + 1 <= 128)
                        newSoundVolume += 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 5 && newMusicVolume + 9 * keystates[ SDLK_LCTRL ] + 1 <= 128)
                        newMusicVolume += 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 6 )
                        newspeedMod += .09 * keystates[ SDLK_LCTRL ] + .01;
                  timeSinceHit = SDL_GetTicks();
            }

            if ( keystates[ SDLK_LEFT ] && SDL_GetTicks() - timeSinceHit > keystrokeDelay / 2.0 )
            {
                  if ( spotOnMenu == 0  && newWidth - ( 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1 ) >= 1)
                        newWidth -= 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 1 && newHeight - ( 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1 ) >= 1)
                        newHeight -= 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 2 && newSampleSize - ( 900 * keystates[ SDLK_LALT ] * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1 ) >= 1)
                        newSampleSize -= 900 * keystates[ SDLK_LALT ] * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 3 && newSampleRate - ( 900 * keystates[ SDLK_LALT ] * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1 ) >= 1)
                        newSampleRate -= 900 * keystates[ SDLK_LALT ] * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 90 * keystates[ SDLK_LSHIFT ] * keystates[ SDLK_LCTRL ] + 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 4 && newSoundVolume - ( 9 * keystates[ SDLK_LCTRL ] + 1)  >= 0 )
                        newSoundVolume -= 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 5 && newMusicVolume - ( 9 * keystates[ SDLK_LCTRL ] + 1)  >= 0 )
                        newMusicVolume -= 9 * keystates[ SDLK_LCTRL ] + 1;
                  else if ( spotOnMenu == 6 && newspeedMod - ( .09 * keystates[ SDLK_LCTRL ] + .01) > 0 )
                        newspeedMod -= .09 * keystates[ SDLK_LCTRL ] + .01;
                  timeSinceHit = SDL_GetTicks();
            }

            if ( newWidth < 1 )
                  newWidth = 1;
            if ( newHeight < 1 )
                  newHeight = 1;
            if ( newSampleSize < 1 )
                  newSampleSize = 1;
            if ( newSampleRate < 1 )
                  newSampleRate = 1;

            //Update the screen (actually display the new frame)
            if( SDL_Flip( screen ) == -1 )
                  return -1;

            //Cap the frame rate
            if( ( SDL_GetTicks() - fpsTimer ) < 1000 / (float)FRAMES_PER_SECOND && capFramerate )
            {
                  SDL_Delay( ( 1000 / (float)FRAMES_PER_SECOND ) - SDL_GetTicks() + fpsTimer );
            }
      }

      //If user hit "Apply Changes"
      if ( spotOnMenu == 7 )
      {
            //If Screen resolution was changed, then reload all images, etc.
            if ( newWidth != SCREEN_WIDTH || newHeight != SCREEN_HEIGHT )
            {
                  //Remove old notices - their images will be the wrong size now
                  eventNoticeList.clear();

                  //Set up the screen, pass current settings in case new ones don't work
                  createScreen( true, newWidth, newHeight, SCREEN_BPP, SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP );

                  scaleFactor = sqrt( SCREEN_WIDTH * SCREEN_WIDTH + SCREEN_HEIGHT * SCREEN_HEIGHT ) / sqrt( 1600 * 1600 + 1200 * 1200 );
                  scaleFactorX = SCREEN_WIDTH / (double)MAX_SCREEN_WIDTH;
                  scaleFactorY = SCREEN_HEIGHT / (double)MAX_SCREEN_HEIGHT;

                  free_surfaces();
                  load_images();

                  //Free fonts
                  TTF_CloseFont( miniFont );
                  TTF_CloseFont( smallFont );
                  TTF_CloseFont( largeFont );

                  //Reload fonts
                  miniFont = TTF_OpenFont( "data/fonts/LiberationSans-Bold.ttf", ( 20 * SCREEN_HEIGHT ) / 768 );
                  smallFont = TTF_OpenFont( "data/fonts/LiberationSans-Bold.ttf", ( 35 * SCREEN_HEIGHT ) / 768 );
                  largeFont = TTF_OpenFont( "data/fonts/LiberationSans-Bold.ttf", ( 50 * SCREEN_HEIGHT ) / 768 );

                  if ( miniFont == NULL ||
                       smallFont == NULL ||
                       largeFont == NULL )
                        quitGame( 1 );
            }

            //If Sample Size or Sample Rate were changed, reinitialize mixer
            if ( newSampleSize != SAMPLE_SIZE || newSampleRate != SAMPLE_RATE )
            {
                  Mix_CloseAudio();
                  SAMPLE_SIZE = newSampleSize;
                  SAMPLE_RATE = newSampleRate;
                  Mix_OpenAudio( SAMPLE_RATE, MIX_DEFAULT_FORMAT, 2, SAMPLE_SIZE );
            }

            //If sound volume was changed, set new volume accordingly
            if ( newSoundVolume != SOUND_VOLUME )
            {
                  //-1 means change volume for all sound channels
                  Mix_Volume( -1, newSoundVolume );
                  SOUND_VOLUME = newSoundVolume;
            }

            //If music volume was changed, set new volume accordingly
            if ( newMusicVolume != MUSIC_VOLUME )
            {
                  Mix_VolumeMusic( newMusicVolume );
                  MUSIC_VOLUME = newMusicVolume;
            }

            //If speedMod was changed, set accordingly
            if ( newspeedMod != speedMod )
            {
                speedMod = newspeedMod;
            }
      }

      return 0;
}
