//Screen size and color depth
int SCREEN_WIDTH = 640;
int SCREEN_HEIGHT = 480;
int MAX_SCREEN_WIDTH = 1600;
int MAX_SCREEN_HEIGHT = 1200;
int SCREEN_BPP = 32;

//Scale Factors used to determine appropriate size relations

//General scalefactor (taken from diagonal)
double scaleFactor = sqrt( SCREEN_WIDTH * SCREEN_WIDTH + SCREEN_HEIGHT * SCREEN_HEIGHT ) / sqrt( 1600 * 1600 + 1200 * 1200 );

//Specific scalefactors for horizontal and vertical relations
double scaleFactorX = SCREEN_WIDTH / (double)MAX_SCREEN_WIDTH;
double scaleFactorY = SCREEN_HEIGHT / (double)MAX_SCREEN_HEIGHT;

//The surfaces
SDL_Surface *screen = NULL;
SDL_Surface *background = NULL;
SDL_Surface *planetImage = NULL;
SDL_Surface *asteroidImage_1 = NULL;
SDL_Surface *asteroidImage_2 = NULL;
SDL_Surface *asteroidImage_3 = NULL;
SDL_Surface *asteroidImage_4 = NULL;
SDL_Surface *asteroidImage_5 = NULL;
SDL_Surface *shipBulletImage = NULL;
SDL_Surface *shipBulletPreviewImage = NULL;
SDL_Surface *turretBulletImage = NULL;
SDL_Surface *turretImage = NULL;
SDL_Surface *exaustParticleImage = NULL;
SDL_Surface *explosionParticleImage = NULL;
SDL_Surface *crosshairsImage = NULL;
SDL_Surface *text = NULL;

SDL_Surface *tempImage = NULL;

//The sound effects that will be used
Mix_Chunk *shipFire = NULL;
Mix_Chunk *turretFire = NULL;
Mix_Chunk *engine = NULL;
Mix_Chunk *asteroidHit = NULL;

//The music that will be played
Mix_Music *music = NULL;

//Various font sizes
TTF_Font *miniFont = NULL;
TTF_Font *smallFont = NULL;
TTF_Font *largeFont = NULL;

//The colors for the various fonts
SDL_Color blackColour = { 0, 0, 0 };
SDL_Color grayColour = { 128, 128, 128 };
SDL_Color whiteColour = { 255, 255, 255 };

//The stringstream used throughout the program
std::stringstream myStringstream;

//Frames Per Second for the game
int FRAMES_PER_SECOND = 30;

//The actual FPS (calculated after each second)
float realFPS = FRAMES_PER_SECOND;

//Timer used to calculate real frames per second
long int updateTimer = SDL_GetTicks();
long int updateTimer2 = SDL_GetTicks();

//The real FPS that is displayed (updated based on realFPSUpdateInterval)
int displayedRealFPS = realFPS;

//How long between checks on the real framerate (500-1000 milliseconds is good)
int realFPSUpdateInterval = 1000;

//Whether to display the Frames Per Second or not
int displayFPS = true;

//Whether to max out computer power and maximize Frames Per Second (still running game at proper speed, but as smoothly as possible)
int ENABLE_MAX_SPEED = false;

//Maximum framerate when Max Speed is enabled
int MAX_FRAMERATE_VARIED = 60;

//Back up previous Frames Per Second for if user disables ENABLE_MAX_SPEED
int SAVED_FPS = 30;

//Delay for keystrokes in menus
int keystrokeDelay = 100;

//Sample size for SDL_Mixer - anything below a ratio of 512:11025 in relation to the Sample Rate seems to stutter - that is, have a Sample Size of 512 for Rate of 11025, 2048 for 44100, etc.
int SAMPLE_SIZE = 2048;

//Mixer sample rate for SDL_Mixer - 22050 is standard, but 44100 is better quality
int SAMPLE_RATE = 44100;

//Sound Volume level (0-128)
int SOUND_VOLUME = 128;

//Music Volume level (0-128)
int MUSIC_VOLUME = 128;

//The event structure that will be used
SDL_Event event;

//The keystate structure for getting keyboard input
Uint8 *keystates;

//Whether or not to cap the frame rate
int capFramerate = true;

//Spot on the main menu
int spotOnMainMenu;

//Whether or not to display crosshairs from the turrets
int displayCrosshairs = true;

//fullscreen status
int fullscreen = false;

//How many frames between turret checking which ship is closest
int timeBetweenTurretCalibrations = 1000;

//Whether or not to play music
int playMusic = true;

//Whether or not to play sounds
int playSounds = true;

int gamePaused = false;

//frame counter used for frame rate calculator
int frame = 0;

//Multiplier of gameplay speed: 1 = normal, 2 = doublespeed, .5 = halfspeed, etc.
float speedMod = 1;

//Used to adjust framerate to appropriate rate (used in conjunction with ENABLE_MAX_SPEED)
double speedMult = 1;

//the Actual ratio used to modify speed
double ratioMult = 1;

//frame counter to keep track of total number of frames rendered
long int allFrames = 0;

int globalID = 0;

int NUM_OF_IMAGE_FRAMES = 4;

int MAX_ACCELERATION = 1;

int PARTICLE_SPEED = 3;
