//Here is the title screen/menu loop
void mainMenu()
{
      int inMenu = 1,
          quit = false,
          fpsTimer;
      while( inMenu && !quit )
      {

            //Play title screen music if not already playing, reload if music stopped
            checkMusic( false, 7 );
            //Display the background
            applySurface( 0, 0, background, screen );

            //Update asteroids
            ratioMult = ( SDL_GetTicks() - updateTimer2 ) / ( 1000 / 30.0 );
            updateTimer2 = SDL_GetTicks();
            objectListUpdate();
            eventNoticeUpdate();
            checkBounds( true );

            //Reapply surfaces
            applySurfaces( 0, 1, 0, 1, 0, 1, 0, 0 );

            //Display the title
            displayTitle();
            text = TTF_RenderText_Solid( miniFont, "version 0.8.2", blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2, 4 * text->h , text, screen );

            //Display the menu items
            if ( spotOnMainMenu == 0 )
                  text = TTF_RenderText_Solid( largeFont, "Play Game", whiteColour );
            else
                  text = TTF_RenderText_Solid( largeFont, "Play Game", blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, SCREEN_HEIGHT - 18 * text->h / 2, text, screen );
            SDL_FreeSurface( text );

            if ( spotOnMainMenu == 1 )
                  text = TTF_RenderText_Solid( largeFont, "Configure Game", whiteColour );
            else
                  text = TTF_RenderText_Solid( largeFont, "Configure Game", blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, SCREEN_HEIGHT - 15 * text->h / 2, text, screen );
            SDL_FreeSurface( text );

            if ( spotOnMainMenu == 2 )
                  text = TTF_RenderText_Solid( largeFont, "Settings", whiteColour );
            else
                  text = TTF_RenderText_Solid( largeFont, "Settings", blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, SCREEN_HEIGHT - 12 * text->h / 2, text, screen );
            SDL_FreeSurface( text );

            if ( spotOnMainMenu == 3 )
                  text = TTF_RenderText_Solid( largeFont, "Quit", whiteColour );
            else
                  text = TTF_RenderText_Solid( largeFont, "Quit", blackColour );
            applySurface( SCREEN_WIDTH / 2 - text->w/2 + 4, SCREEN_HEIGHT - 9 * text->h / 2, text, screen );
            SDL_FreeSurface( text );

            //Start the frame timer
            fpsTimer = SDL_GetTicks();

            //Toggle fullscreen if user pressed alt-enter
            keystates = SDL_GetKeyState( NULL );
            checkFullscreenToggle();

            //While there's events to handle
            while( SDL_PollEvent( &event ) )
            {
                  //If the user has Xed out the window
                  if ( event.type == SDL_QUIT )
                  {
                        //Quit the program
                        quitGame( 0 );
                  }

                  if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_DOWN )
                  {
                        spotOnMainMenu++;
                  }

                  if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_UP )
                  {
                        spotOnMainMenu--;
                  }

                  if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_RETURN && !keystates[ SDLK_LALT ] && !keystates[ SDLK_RALT ] )
                        inMenu = false;

                  if ( event.type == SDL_KEYDOWN && event.key.keysym.sym == SDLK_ESCAPE )
                  {
                        inMenu = false;
                  }
            }

            if ( spotOnMainMenu > 3 )
                  spotOnMainMenu = 0;
            if ( spotOnMainMenu < 0 )
                  spotOnMainMenu = 3;

            //Update the screen (actually display the new frame)
            if( SDL_Flip( screen ) == -1 )
                  quitGame( 1000 );

            //Cap the frame rate
            if( ( SDL_GetTicks() - fpsTimer ) < 1000 / (float)FRAMES_PER_SECOND && capFramerate )
            {
                  SDL_Delay( ( 1000 / (float)FRAMES_PER_SECOND ) - SDL_GetTicks() + fpsTimer );
            }
      }
}
