void createShip( int playerNum, float x, float y)
{
      playerList[playerNum].theShip.x = x;
      playerList[playerNum].theShip.y = y;
      playerList[playerNum].theShip.hasPull = false;
      playerList[playerNum].theShip.shotSpeed = 11;
      playerList[playerNum].theShip.shotRechargeTime = 425;
      playerList[playerNum].theShip.bulletTime = playerList[playerNum].theShip.shotRechargeTime;
      playerList[playerNum].theShip.mass = .05;
      playerList[playerNum].theShip.xVel = 0;
      playerList[playerNum].theShip.yVel = 0;
      playerList[playerNum].theShip.angle = ( rand() % 36000 ) / 100.0;
      playerList[playerNum].theShip.thrust = .13;
      playerList[playerNum].theShip.rotateSpeed = .115;
      playerList[playerNum].theShip.invincible = false;
      playerList[playerNum].theShip.justRegenerated = true;
      playerList[playerNum].theShip.timeToRegen = 3;
      playerList[playerNum].theShip.timeOfRegen = SDL_GetTicks();
      playerList[playerNum].theShip.lengthOfNewness = 3000;
      playerList[playerNum].theShip.secondImage = shipBulletImage;
      playerList[playerNum].theShip.shootsMagneticBullets = false;
}

turret createTurret( float x, float y, float mass )
{
      turret myTurret;

      myTurret.x = x;
      myTurret.y = y;
      myTurret.hasPull = false;
      myTurret.shotSpeed = myLevel.turretShotSpeed;
      myTurret.shotRechargeTime = myLevel.turretRechargeTime;
      myTurret.bulletTime = myTurret.shotRechargeTime + rand() % ( myTurret.shotRechargeTime + 2 );
      myTurret.maxBulletLife = myLevel.turretBulletLife;
      myTurret.mass = mass;
      myTurret.xVel = 0;
      myTurret.yVel = 0;
      myTurret.angle = 0;
      myTurret.rotateSpeed = myLevel.turretRotateSpeed;

      myTurret.image = turretImage;
      myTurret.secondImage = turretBulletImage;

      return myTurret;
}

//Create the level from the difficulty level passed
void createLevel( int currentLevelNumber, int overallDifficulty )
{
      myLevel.numOfAsteroids = 2 + (int)( sqrtf( 2.25 * currentLevelNumber ) ) + 1.25 * ( overallDifficulty - 1 );
      myLevel.numOfPlanets = (int)( sqrtf( 1.2 * currentLevelNumber ) ) - 1;
      myLevel.planetMassUpper = (int)( sqrtf( 8 * currentLevelNumber ) ) + 2;
      myLevel.planetMassLower = (int)( sqrtf( 8 * currentLevelNumber ) );
      myLevel.numOfTurrets = (int)( sqrtf( .8 * currentLevelNumber + 20 ) ) - 4;
      myLevel.asteroidSplitCount = ( overallDifficulty / 3 + 2 );
      myLevel.asteroidLives = -10 / ( overallDifficulty + 4 ) + 5;
      myLevel.turretRechargeTime = 800.0 / ( currentLevelNumber / 30.0 ) - 50 * ( overallDifficulty - 1 );
      myLevel.turretShotSpeed = .02 * currentLevelNumber + .5 * overallDifficulty + 4;

      myLevel.turretBulletLife = 1000 + ( 140 * overallDifficulty - 150 ) + 100 * currentLevelNumber;
      myLevel.turretRotateSpeed = overallDifficulty * .0045 * currentLevelNumber;
}

void createAPlayer()
{
      player myPlayer;

      playerList.push_back( myPlayer );
}

void createAllShips()
{
      int i,
          playerListSize = playerList.size();

      //Randomly create and position the ships
      for ( i = 0 ; i < playerListSize ; i++ )
      {
            createShip( i, rand() % MAX_SCREEN_WIDTH, rand() % MAX_SCREEN_HEIGHT );
            playerList[i].theShip.invincible = true;
            playerList[i].theShip.justRegenerated = true;
      }
}

void createPlayerList()
{
      int i;

      playerList.clear();

      //create all of the players
      for ( i = 0 ; i < theWorld.numOfPlayers ; i++ )
            createAPlayer();
}

//Populate objects based on level information
void createObjects()
{
      int i;

      //Clear the vectors
      objectList.clear();
      bulletList.clear();
      particleList.clear();
      turretList.clear();

      //Create the list containing all the ships
      createAllShips();

      //Randomly create the planets
      for ( i = 0 ; i < myLevel.numOfPlanets ; i++ )
             objectList.push_back( createPlanet( rand() % MAX_SCREEN_WIDTH,
                                                 rand() % MAX_SCREEN_HEIGHT,
                                                 ( rand() % ( (int)( myLevel.planetMassUpper - myLevel.planetMassLower ) + 1 ) ) + myLevel.planetMassLower ) );

      //Randomly create the asteroids
      for ( i = 0 ; i < myLevel.numOfAsteroids ; i++ )
            objectList.push_back( createAsteroid( rand() % MAX_SCREEN_WIDTH,
                                                  rand() % MAX_SCREEN_HEIGHT,
                                                  ( rand() % 1000 - 500 ) / 350.0,
                                                  ( rand() % 1000 - 500 ) / 350.0,
                                                  false,
                                                  4, 3, theWorld.overallDifficulty * .1 + 1 ) );

      //Randomly create the turrets
      for ( i = 0 ; i < myLevel.numOfTurrets ; i++ )
            turretList.push_back( createTurret( rand() % MAX_SCREEN_WIDTH,
                                                rand() % MAX_SCREEN_HEIGHT,
                                                .1 ) );
}
