int playGame()
{
      int i,
          quit = false,
          numOfAsteroids,
          thereArePlayersLeft = true,
          fpsTimer,
          gameUpdateTimer = SDL_GetTicks(),
          initialFrames = 0;

      //Start playing music
      checkMusic( true, 0 );

      thereArePlayersLeft = true;

      myStringstream.clear();
      myStringstream.str("");
      myStringstream << "New game started with " << playerList.size() << " player";
      if ( playerList.size() > 1 )
            myStringstream << "s";
      myStringstream << " at difficulty level " << theWorld.overallDifficulty;

      addEvent( myStringstream.str().c_str(), 6000 );

      while ( 1 )
      {
            myStringstream.clear();
            myStringstream.str("");
            myStringstream << "Starting Level " << theWorld.currentLevelNumber;

            addEvent( myStringstream.str().c_str(), 6000 );

            //Create the level based on the difficulty of the level and overall difficulty
            createLevel( theWorld.currentLevelNumber, theWorld.overallDifficulty );
            numOfAsteroids = myLevel.numOfAsteroids;

            //Create all of the objects, including ship
            createObjects();

            //Reset timer used to update calculated, real FPS
            updateTimer2 = SDL_GetTicks();

            // MAIN GAME LOOP
            //While the user hasn't quit and while level is still going on and all players aren't dead
            while( quit == false && numOfAsteroids > 0 && thereArePlayersLeft )
            {

                  numOfAsteroids = getNumOfAsteroids();

                   //Start the frame timer
                  fpsTimer = SDL_GetTicks();

                  //Get keystates
                  keystates = SDL_GetKeyState( NULL );
                  //Check if user pressing alt-enter
                  checkFullscreenToggle();

                  //While there's events to handle
                  while( SDL_PollEvent( &event ) )
                  {
                        //If the user has Xed out the window
                        if( event.type == SDL_QUIT )
                        {
                              //Quit the program
                              quit = true;
                        }

                        if ( event.type == SDL_KEYDOWN )
                        {
                              if ( keystates[ SDLK_RALT ] || keystates[ SDLK_LALT ] )
                              {
                                    switch ( event.key.keysym.sym )
                                    {
                                          //If user hit u, enable or disable frame rate capping
                                          case SDLK_u:
                                                capFramerate = !capFramerate;
                                                if ( capFramerate )
                                                      addEvent( "Framerate capping enabled", 3000 );
                                                else
                                                      addEvent( "Framerate capping disabled", 3000 );
                                                break;
                                          //If user hit q, enable or disable displaying the turret crosshairs
                                          case SDLK_q:
                                                displayCrosshairs = !displayCrosshairs;
                                                if ( displayCrosshairs )
                                                      addEvent( "Crosshair display enabled", 3000 );
                                                else
                                                      addEvent( "Crosshair display disabled", 3000 );
                                                break;
                                          //If user hit f, enable or disable displaying the FPS
                                          case SDLK_f:
                                                displayFPS = !displayFPS;
                                                if ( displayFPS )
                                                      addEvent( "FPS display enabled", 3000 );
                                                else
                                                      addEvent( "FPS display disabled", 3000 );
                                                break;
                                          //If user hits m, turn music on or off
                                          case SDLK_m:
                                                playMusic = !playMusic;
                                                checkMusic( false, 0 );
                                                if ( playMusic )
                                                      addEvent( "Music ON", 3000 );
                                                else
                                                      addEvent( "Music OFF", 3000 );
                                                break;
                                          //If user hits s, turn sounds on or off
                                          case SDLK_s:
                                                playSounds = !playSounds;
                                                if ( playSounds )
                                                      addEvent( "Sounds ON", 3000 );
                                                else
                                                      addEvent( "Sounds OFF", 3000 );
                                                break;
                                          //If user hits p, skip to next level
                                          case SDLK_p:
                                                numOfAsteroids = 0;
                                                for ( i = 0 ; i < objectList.size() ; i++ )
                                                      if ( objectList[i].name == ASTEROID )
                                                            objectList[i].exist = 0;
                                                break;
                                          //If user hits w, change whether or not ships can kill each other
                                          case SDLK_w:
                                                for ( i = 0 ; i < playerList.size() ; i++ )
                                                      playerList[i].theShip.killsOtherShips = ( !playerList[i].theShip.killsOtherShips );
                                                if ( playerList[0].theShip.killsOtherShips )
                                                      addEvent( "Team attack ON", 3000 );
                                                else
                                                      addEvent( "Team attack OFF", 3000 );
                                                break;
                                          //If user hits o, go back 1 level
                                          case SDLK_o:
                                                if ( theWorld.currentLevelNumber > 1 )
                                                {
                                                      theWorld.currentLevelNumber -= 2;
                                                      numOfAsteroids = 0;
                                                      for ( i = 0 ; i < objectList.size() ; i++ )
                                                            if ( objectList[i].name == ASTEROID )
                                                                  objectList[i].exist = 0;
                                                }
                                                break;
                                          case SDLK_l:
                                                theWorld.overallDifficulty++;
                                                theWorld.currentLevelNumber--;
                                                for ( i = 0 ; i < objectList.size() ; i++ )
                                                      if ( objectList[i].name == ASTEROID )
                                                            objectList[i].exist = 0;
                                                break;
                                                myStringstream.clear();
                                                myStringstream.str("");
                                                myStringstream << "Difficulty level set to " << theWorld.overallDifficulty;
                                                addEvent( myStringstream.str().c_str(), 3000 );
                                          //If user hits o, go back 1 level
                                          case SDLK_k:
                                                if ( theWorld.overallDifficulty > 1 )
                                                {
                                                      theWorld.overallDifficulty--;
                                                      theWorld.currentLevelNumber--;
                                                      numOfAsteroids = 0;
                                                      for ( i = 0 ; i < objectList.size() ; i++ )
                                                            if ( objectList[i].name == ASTEROID )
                                                                  objectList[i].exist = 0;
                                                      myStringstream.clear();
                                                      myStringstream.str("");
                                                      myStringstream << "Difficulty level set to " << theWorld.overallDifficulty;
                                                      addEvent( myStringstream.str().c_str(), 3000 );
                                                }
                                                break;
                                          //If user hits n, change song randomly
                                          case SDLK_n:
                                                checkMusic( true, 0 );
                                                break;
            //Invincibility debug mode disabled for now
            /*
                                          //If user hits i, turn invincibility on or off
                                          case SDLK_i:
                                                if ( playerList[j].theShip.justRegenerated )
                                                {
                                                      playerList[j].theShip.invincible = false;
                                                      playerList[j].theShip.justRegenerated = false;
                                                }
                                                else
                                                      playerList[j].theShip.invincible = ( !playerList[j].theShip.invincible );
                                                break;
            */
                                          //If user hits 1-6, change music to that song
                                          case SDLK_1:
                                                checkMusic( true, 1 );
                                                break;
                                          case SDLK_2:
                                                checkMusic( true, 2 );
                                                break;
                                          case SDLK_3:
                                                checkMusic( true, 3 );
                                                break;
                                          case SDLK_4:
                                                checkMusic( true, 4 );
                                                break;
                                          case SDLK_5:
                                                checkMusic( true, 5 );
                                                break;
                                          case SDLK_6:
                                                checkMusic( true, 6 );
                                                break;
                                          case SDLK_KP_MINUS:
                                                if ( FRAMES_PER_SECOND > 1 && !ENABLE_MAX_SPEED )
                                                {
                                                      FRAMES_PER_SECOND--;
                                                      myStringstream.clear();
                                                      myStringstream.str("");
                                                      myStringstream << "Frames Per Second set to " << FRAMES_PER_SECOND;
                                                      addEvent( myStringstream.str().c_str(), 3000 );
                                                }
                                                break;
                                          case SDLK_KP_PLUS:
                                                if ( !ENABLE_MAX_SPEED )
                                                {
                                                      FRAMES_PER_SECOND++;
                                                      myStringstream.clear();
                                                      myStringstream.str("");
                                                      myStringstream << "Frames Per Second set to " << FRAMES_PER_SECOND;
                                                      addEvent( myStringstream.str().c_str(), 3000 );
                                                }
                                                break;
                                          case SDLK_MINUS:
                                                if ( MAX_FRAMERATE_VARIED > 1 )
                                                {
                                                      MAX_FRAMERATE_VARIED--;
                                                      myStringstream.clear();
                                                      myStringstream.str("");
                                                      myStringstream << "Max Variable Framerate set to " << MAX_FRAMERATE_VARIED;
                                                      addEvent( myStringstream.str().c_str(), 3000 );
                                                }
                                                break;
                                          case SDLK_EQUALS:
                                                MAX_FRAMERATE_VARIED++;
                                                myStringstream.clear();
                                                myStringstream.str("");
                                                myStringstream << "Max Variable Framerate set to " << MAX_FRAMERATE_VARIED;
                                                addEvent( myStringstream.str().c_str(), 3000 );
                                                break;
                                          case SDLK_0:
                                                ENABLE_MAX_SPEED = !ENABLE_MAX_SPEED;
                                                if ( ENABLE_MAX_SPEED == false )
                                                {
                                                      FRAMES_PER_SECOND = SAVED_FPS;
                                                      addEvent( "Maximum Speed disabled", 3000 );
                                                }
                                                else
                                                {
                                                      SAVED_FPS = FRAMES_PER_SECOND;
                                                      addEvent( "Maximum Speed enabled", 3000 );
                                                }
                                                break;
                                          default:
                                                break;
                                    }
                              }
                              else if ( event.key.keysym.sym == SDLK_ESCAPE )
                              {
                                                Mix_HaltMusic();
                                                bulletList.clear();
                                                particleList.clear();
                                                return true;
                              }
                              else if ( event.key.keysym.sym == SDLK_PAUSE )
                              {
                                    gamePaused = !gamePaused;
                                    if ( gamePaused )
                                          addEvent( "Game paused", 3000 );
                                    else
                                          addEvent( "Game unpaused", 3000 );
                              }
                        }
                  }

                  //Update all objects, bullets, the ship, etc. if game is unpaused
                  if ( !gamePaused )
                        update();
                  else //If game is paused, still update notices and remove dead ones
                      eventNoticeUpdate();

                  //Reapply surfaces
                  applySurfaces( 1, 1, 1, 1, 1, 1, 1, 1 );

                  //Test FPS without applying surfaces
                  //applySurfaces( 0, 0, 0, 0, 0, 0, 0, 1 );

                  //Update the screen (actually display the new frame)
                  if( SDL_Flip( screen ) == -1 )
                        return 1;

                  frame++;          //Increment number of frames displayed since last caption update
                  if ( !gamePaused )
                        allFrames++;      //Increments total frames displayed

                  //Porcess secondly events, like the caption update
                  if( SDL_GetTicks() - gameUpdateTimer > 1000 )
                  {
                        gameUpdateTimer = SDL_GetTicks();

                        //Update the real FPS that's currently being displayed
                        displayedRealFPS = (int)realFPS;
// Caption update
/*
                        myStringstream.clear();
                        myStringstream.str("");
                        myStringstream << "Player 1 Speed: " << sqrt( playerList[0].theShip.xVel * playerList[0].theShip.xVel + playerList[0].theShip.yVel * playerList[0].theShip.yVel );

                        SDL_WM_SetCaption( myStringstream.str().c_str(), NULL );
*/

                        //If not playing music when it should be (i.e. the song ended), play a new song
                        if ( !Mix_PlayingMusic() && playMusic )
                              checkMusic( true, 0 );

                        thereArePlayersLeft = false;

                        for ( i = 0 ; i < playerList.size() ; i++ )
                              if ( playerList[i].lives > 0 )
                                    thereArePlayersLeft = true;
                  }

                  //Use to determine if program "waited" at all before going to next frame
                  initialFrames = SDL_GetTicks();

                  //Cap the frame rate
                  if( ( SDL_GetTicks() - fpsTimer ) < 1000 / (float)FRAMES_PER_SECOND && capFramerate )
                  {
                        SDL_Delay( ( 1000 / (float)FRAMES_PER_SECOND ) - SDL_GetTicks() + fpsTimer );
                  }

                  if ( ENABLE_MAX_SPEED && capFramerate )
                  {
                        if ( SDL_GetTicks() - initialFrames  > 2 && FRAMES_PER_SECOND < MAX_FRAMERATE_VARIED )
                              FRAMES_PER_SECOND++;
                        else if ( SDL_GetTicks() - initialFrames  == 0 || FRAMES_PER_SECOND > MAX_FRAMERATE_VARIED)
                              FRAMES_PER_SECOND--;
                  }
            }

            //If user quit, return to title screen and indicate that user is no longer in program
            if ( quit == true )
            {
                  return false;
            }
            //Else if all players are dead
            else if ( thereArePlayersLeft == false )
            {
                  return true;
            }
            //Otherwise, increment difficulty level and go to next level
            else
            {
                  theWorld.currentLevelNumber++;
                  //Level scoring not yet implemented
                  //myPlayer.score += (int)( ( ( 2 * myLevel.numOfAsteroids ) + ( 3 * myLevel.numOfPlanets ) + ( 4 * myLevel.numOfTurrets ) ) * 30 * ( .5 * myPlayer.overallDifficulty + .5 ) );
            }
      }
}
