class turret
{
      public:

      //Unique id for this object
      int ID;

      //Does turret still exist? (is it dead)
      int exist;

      //Pointer to the closest ship (the one to target)
      int playerWithClosestShip;

      //Time in milliseconds since last time ship was targeted
      int timeSinceTargeting;

      //Location in space
      double x, y;

      //The velocity of the object
      double xVel,
             yVel;

      //Whether or not object has a gravitational pull
      int hasPull;

      //Whether or not object is affected by gravity
      int canBePulled;

      //Keeps track of time since last bullet was shot (in ticks)
      int bulletTime;

      //How much time between bullet shots (in frames)
      int shotRechargeTime;

      //Speed at which bullets are shot
      float shotSpeed;

      //HJow long bullets last
      float maxBulletLife;

      //The mass of the object
      float mass;

      //The angle of the object (from the vertical)
      double angle;

      float projX;
      float projY;

      //The Rotation speed of the object
      float rotateSpeed;

      //Pointer to the images used for the object
      SDL_Surface *image;
      SDL_Surface *secondImage;

      //The constructor
      turret();

      //Assign an ID to the object
      void assign();

      //Find the closest ship and give the turret the address
      void findClosestShip();

      void createStandardBullet();
};

turret::turret()
{
      exist = true;
      image = NULL;
      secondImage = NULL;
      mass = .01;
      angle = 0;
      canBePulled = true;
      hasPull = false;
      ID = globalID;
      globalID++;
      playerWithClosestShip = 0;
      timeSinceTargeting = 500;
}

//Create a standard bullet and add it to the list of bullets
void turret::createStandardBullet()
{
      bullet myBullet;
      myBullet.x = this->x + ( this->image->w / ( 2.0 * scaleFactorX ) ) * cos( this->angle );
      myBullet.y = this->y + ( this->image->h / ( 2.0 * scaleFactorY ) ) * sin( this->angle );
      myBullet.xVel = this->shotSpeed * cos( this->angle );
      myBullet.yVel = this->shotSpeed * sin( this->angle );
      myBullet.hasPull = false;
      myBullet.canBePulled = false;
      myBullet.maxLife = this->maxBulletLife;
      myBullet.ID = this->ID;
      myBullet.image = turretBulletImage;
      myBullet.killsShips = true;

      bulletList.push_back( myBullet );
      if ( playSounds )
            Mix_PlayChannel( -1, turretFire, 0 );
}

void turret::findClosestShip()
{
      int i,
          playerListSize = playerList.size();

      float thisDistance,
            shortestDistance = 0;

      if ( playerListSize > 0 )
            shortestDistance = distance( this->x, this->y, playerList[0].theShip.x, playerList[0].theShip.y ) + 1;

      for ( i = 0 ; i < playerListSize ; i++ )
      {
            thisDistance = distance( this->x, this->y, playerList[i].theShip.x, playerList[i].theShip.y );
            if ( thisDistance <= shortestDistance && playerList[i].theShip.exist && playerList[i].lives > 0 )
            {
                  this->playerWithClosestShip = i;
                  shortestDistance = thisDistance;
            }
      }
}
